/* nevars.h: this header file was produced automatically by
 * the ./mktbls program, based on input from the file modetbl
 */

#if OPT_EVAL

/*	structure to hold user variables and their definitions	*/

typedef struct UVAR {
	struct UVAR *next;
	char *u_name;		/* name of user variable */
	char *u_value;				/* value (string) */
} UVAR;

decl_uninit( UVAR *user_vars );	/* user variables */


/*	list of recognized environment variables	*/

#ifdef realdef
char *envars[] = {
	s_abufname__,
#if PROC
	s_buffer_hook__,
#endif
	s_cbufname__,
#if PROC
	s_cd_hook__,
#endif
	s_cfilname__,
	s_char__,
	s_curcol__,
	s_curline__,
	s_cwd__,
	s_cwline__,
	s_debug__,
	s_directory__,
	s_discmd__,
	s_disinp__,
#if PROC
	s_exit_hook__,
#endif
	s_flicker__,
#if X11
	s_font__,
	s_iconname__,
#endif
	s_identifier__,
	s_kill__,
	s_lastkey__,
	s_line__,
	s_llength__,
	s_match__,
	s_mode__,
	s_ntildes__,
	s_ocwd__,
	s_os__,
	s_pagelen__,
	s_pagewid__,
	s_palette__,
	s_pathname__,
	s_pending__,
	s_progname__,
	s_qidentifier__,
#if RAMSIZE
	s_ram__,
#endif
#if PROC
	s_read_hook__,
#endif
	s_replace__,
	s_search__,
	s_seed__,
	s_shell__,
	s_sres__,
	s_status__,
#if X11
	s_title__,
#endif
	s_tpause__,
	s_version__,
	s_wline__,
	s_word__,
#if PROC
	s_write_hook__,
#endif
	NULL	/* ends table for name-completion */
};
#else
extern char *envars[];
#endif

/* 	and its preprocesor definitions		*/

typedef	struct	{
	char	s_abufname__;	/* alternate buffer name (i.e. '#') */
#if PROC
	char	s_buffer_hook__; /* procedure to run when entering buf */
#endif
	char	s_cbufname__;	/* current buffer name */
#if PROC
	char	s_cd_hook__;	/* procedure to run when cd'ing */
#endif
	char	s_cfilname__;	/* current file name */
	char	s_char__;	/* current character under the cursor */
	char	s_curcol__;	/* current column pos of cursor */
	char	s_curline__;	/* current line in file */
	char	s_cwd__;	/* current directory */
	char	s_cwline__;	/* current screen line in window */
	char	s_debug__;	/* macro debugging */
	char	s_directory__;	/* controls location of temp-files */
	char	s_discmd__;	/* display commands on command line */
	char	s_disinp__;	/* display command line input characters */
#if PROC
	char	s_exit_hook__;	/* procedure to run when quitting */
#endif
	char	s_flicker__;	/* flicker suppression */
#if X11
	char	s_font__;	/* current font */
	char	s_iconname__;	/* current font */
#endif
	char	s_identifier__; /* current identifier */
	char	s_kill__;	/* kill buffer (read only) */
	char	s_lastkey__;	/* last keyboard char struck */
	char	s_line__;	/* text of current line */
	char	s_llength__;	/* length of current line */
	char	s_match__;	/* last matched magic pattern */
	char	s_mode__;	/* are we inserting/overwriting/command */
	char	s_ntildes__;	/* number of tildes displayed at eob */
	char	s_ocwd__;	/* previous directory */
	char	s_os__;		/* what os are we on? */
	char	s_pagelen__;	/* number of lines used by editor */
	char	s_pagewid__;	/* current screen width */
	char	s_palette__;	/* current palette string */
	char	s_pathname__;	/* current path-like word */
	char	s_pending__;	/* type ahead pending flag */
	char	s_progname__;	/* returns current prog name - "vile" */
	char	s_qidentifier__; /* current qualified identifier */
#if RAMSIZE
	char	s_ram__;	/* ram in use by malloc */
#endif
#if PROC
	char	s_read_hook__;	/* procedure to run when reading */
#endif
	char	s_replace__;	/* replacement pattern */
	char	s_search__;	/* search pattern */
	char	s_seed__;	/* current random number seed */
	char	s_shell__;	/* shell-environment variable */
	char	s_sres__;	/* current screen resolution */
	char	s_status__;	/* returns the status of the last command */
#if X11
	char	s_title__;	/* window title */
#endif
	char	s_tpause__;	/* length to pause for paren matching */
	char	s_version__;	/* current version number */
	char	s_wline__;	/* # of lines in current window */
	char	s_word__;	/* current word */
#if PROC
	char	s_write_hook__; /* procedure to run when writing */
#endif
	char	s_MAX;
	char	Q1;
	} IndexVars;

#define	EVABUFNAME	OFFSETOF(IndexVars, s_abufname__)
#if PROC
#define	EVBUFHOOK	OFFSETOF(IndexVars, s_buffer_hook__)
#endif
#define	EVCBUFNAME	OFFSETOF(IndexVars, s_cbufname__)
#if PROC
#define	EVCDHOOK	OFFSETOF(IndexVars, s_cd_hook__)
#endif
#define	EVCFNAME	OFFSETOF(IndexVars, s_cfilname__)
#define	EVCURCHAR	OFFSETOF(IndexVars, s_char__)
#define	EVCURCOL	OFFSETOF(IndexVars, s_curcol__)
#define	EVCURLINE	OFFSETOF(IndexVars, s_curline__)
#define	EVCWD		OFFSETOF(IndexVars, s_cwd__)
#define	EVCWLINE	OFFSETOF(IndexVars, s_cwline__)
#define	EVDEBUG		OFFSETOF(IndexVars, s_debug__)
#define	EVDIRECTORY	OFFSETOF(IndexVars, s_directory__)
#define	EVDISCMD	OFFSETOF(IndexVars, s_discmd__)
#define	EVDISINP	OFFSETOF(IndexVars, s_disinp__)
#if PROC
#define	EVEXITHOOK	OFFSETOF(IndexVars, s_exit_hook__)
#endif
#define	EVFLICKER	OFFSETOF(IndexVars, s_flicker__)
#if X11
#define	EVFONT		OFFSETOF(IndexVars, s_font__)
#define	EVICONNAM	OFFSETOF(IndexVars, s_iconname__)
#endif
#define	EVIDENTIF	OFFSETOF(IndexVars, s_identifier__)
#define	EVKILL		OFFSETOF(IndexVars, s_kill__)
#define	EVLASTKEY	OFFSETOF(IndexVars, s_lastkey__)
#define	EVLINE		OFFSETOF(IndexVars, s_line__)
#define	EVLLENGTH	OFFSETOF(IndexVars, s_llength__)
#define	EVMATCH		OFFSETOF(IndexVars, s_match__)
#define	EVMODE		OFFSETOF(IndexVars, s_mode__)
#define	EVNTILDES	OFFSETOF(IndexVars, s_ntildes__)
#define	EVOCWD		OFFSETOF(IndexVars, s_ocwd__)
#define	EVOS		OFFSETOF(IndexVars, s_os__)
#define	EVPAGELEN	OFFSETOF(IndexVars, s_pagelen__)
#define	EVCURWIDTH	OFFSETOF(IndexVars, s_pagewid__)
#define	EVPALETTE	OFFSETOF(IndexVars, s_palette__)
#define	EVPATHNAME	OFFSETOF(IndexVars, s_pathname__)
#define	EVPENDING	OFFSETOF(IndexVars, s_pending__)
#define	EVPROGNAME	OFFSETOF(IndexVars, s_progname__)
#define	EVQIDENTIF	OFFSETOF(IndexVars, s_qidentifier__)
#if RAMSIZE
#define	EVRAM		OFFSETOF(IndexVars, s_ram__)
#endif
#if PROC
#define	EVRDHOOK	OFFSETOF(IndexVars, s_read_hook__)
#endif
#define	EVREPLACE	OFFSETOF(IndexVars, s_replace__)
#define	EVSEARCH	OFFSETOF(IndexVars, s_search__)
#define	EVSEED		OFFSETOF(IndexVars, s_seed__)
#define	EVSHELL		OFFSETOF(IndexVars, s_shell__)
#define	EVSRES		OFFSETOF(IndexVars, s_sres__)
#define	EVSTATUS	OFFSETOF(IndexVars, s_status__)
#if X11
#define	EVTITLE		OFFSETOF(IndexVars, s_title__)
#endif
#define	EVTPAUSE	OFFSETOF(IndexVars, s_tpause__)
#define	EVVERSION	OFFSETOF(IndexVars, s_version__)
#define	EVWLINE		OFFSETOF(IndexVars, s_wline__)
#define	EVWORD		OFFSETOF(IndexVars, s_word__)
#if PROC
#define	EVWRHOOK	OFFSETOF(IndexVars, s_write_hook__)
#endif

/*	list of recognized user functions	*/

typedef struct UFUNC {
	char *f_name;	/* name of function */
	int f_type;	/* 1 = monamic, 2 = dynamic */
} UFUNC;

#define	NILNAMIC	0
#define	MONAMIC		1
#define	DYNAMIC		2
#define	TRINAMIC	3

#ifdef realdef
UFUNC funcs[] = {
	{"abs", MONAMIC},	/* absolute value of a number */
	{"add", DYNAMIC},	/* add two numbers together */
	{"and", DYNAMIC},	/* logical and */
	{"asc", MONAMIC},	/* char to integer conversion */
	{"bin", MONAMIC},	/* lookup what function name is bound to a key */
	{"cat", DYNAMIC},	/* concatenate string */
	{"chr", MONAMIC},	/* integer to char conversion */
	{"div", DYNAMIC},	/* division */
	{"env", MONAMIC},	/* retrieve a system environment var */
	{"equ", DYNAMIC},	/* logical equality check */
	{"gre", DYNAMIC},	/* logical greater than */
	{"gtk", NILNAMIC},	/* get 1 character */
	{"ind", MONAMIC},	/* evaluate indirect value */
	{"lef", DYNAMIC},	/* left string(string, len) */
	{"len", MONAMIC},	/* string length */
	{"les", DYNAMIC},	/* logical less than */
	{"low", MONAMIC},	/* lower case string */
	{"mid", TRINAMIC},	/* mid string(string, pos, len) */
	{"mod", DYNAMIC},	/* modulo */
	{"neg", MONAMIC},	/* negate */
	{"not", MONAMIC},	/* logical not */
	{"or", DYNAMIC},	/* logical or */
	{"rd", MONAMIC},	/* is a file readable? */
	{"rig", DYNAMIC},	/* right string(string, pos) */
	{"rnd", MONAMIC},	/* get a random number */
	{"seq", DYNAMIC},	/* string logical equality check */
	{"sgr", DYNAMIC},	/* string logical greater than */
	{"sin", DYNAMIC},	/* find the index of one string in another */
	{"sle", DYNAMIC},	/* string logical less than */
	{"sub", DYNAMIC},	/* subtraction */
	{"tim", DYNAMIC},	/* multiplication */
	{"tru", MONAMIC},	/* Truth of the universe logical test */
	{"upp", MONAMIC},	/* uppercase string */
	{"wr", MONAMIC},	/* is a file writeable? */
};
#else
extern UFUNC funcs[];
#endif

/* 	and its preprocesor definitions		*/

#define	UFABS		0
#define	UFADD		1
#define	UFAND		2
#define	UFASCII		3
#define	UFBIND		4
#define	UFCAT		5
#define	UFCHR		6
#define	UFDIV		7
#define	UFENV		8
#define	UFEQUAL		9
#define	UFGREATER	10
#define	UFGTKEY		11
#define	UFIND		12
#define	UFLEFT		13
#define	UFLENGTH	14
#define	UFLESS		15
#define	UFLOWER		16
#define	UFMID		17
#define	UFMOD		18
#define	UFNEG		19
#define	UFNOT		20
#define	UFOR		21
#define	UFREADABLE	22
#define	UFRIGHT		23
#define	UFRND		24
#define	UFSEQUAL	25
#define	UFSGREAT	26
#define	UFSINDEX	27
#define	UFSLESS		28
#define	UFSUB		29
#define	UFTIMES		30
#define	UFTRUTH		31
#define	UFUPPER		32
#define	UFWRITABLE	33

#define	NFUNCS		34

#endif /* OPT_EVAL */
